--mod-version:3
local syntax = require 'core.syntax'

syntax.add {
	name = "Zongor's Transpiler Language",
	files = { "%.ztl$" },
	block_comment = { '/*', '*/' },
	patterns = {
		{ pattern = { "/%*", "%*/" },     type = "comment"  },
    { pattern = { '"', '"', '\\' },   type = "string" },
    { pattern = { "'", "'", '\\' },   type = "string" },
		{ pattern = ";",                  type = "operator" },
		{ pattern = "[%a_][%w_]*()%s*%(", type = {"function", "normal"} },
    { pattern = "[viu][%d_]+",         type = "keyword2" },
		{ pattern = "[A-Z][%w_]*",        type = "keyword2" },
		{ pattern = "[9][%w_]*",          type = "keyword2" },
		{ pattern = ":[%w_]*",            type = "literal"   },
    { pattern = "-?%.?%d+f?",         type = "number"   },
	},
	symbols = {
	  ["fn"]  = "keyword",
	  ["to"]  = "keyword",
	  ["in"]  = "keyword",
		["use"] = "keyword",
		["set"] = "keyword",
		["if"] = "keyword",
		["else"] = "keyword",
		["for"] = "keyword",
		["while"] = "keyword",
		["push"] = "keyword",
		["pop"] = "keyword",
		["return"] = "keyword",
		["immutable"] = "keyword",
		["type"] = "keyword",

    ["char"] = "keyword2",
    ["str"] = "keyword2",
    ["f16"] = "keyword2",
    ["f32"] = "keyword2",
    ["f64"] = "keyword2",
    ["f128"] = "keyword2",

    ["true"]            = "literal",
    ["false"]           = "literal",
	}}
